
#define _CRT_SECURE_NO_DEPRECATE

#include "BasicRenderer.h"
#define PI		(3.141529f)



BasicRenderer::BasicRenderer(DX11_CORE* dx11_core, CommonShader* comShader, CommonTexture* comTexture, UINT vertexBufSz, UINT indexBufSz ){

	
	m_dx11_core = dx11_core;
	m_comShader = comShader;
	m_comTexture = comTexture;	
	

//DXnIuWFNgϐNULLZbg.
	m_pVertexShader = NULL;
	m_pPixelShader = NULL;
	m_pVertexLayout = NULL;
	m_pVertexBuffer = NULL;
	m_pIndexBuffer = NULL;
    m_pWVPBuffer = NULL;
    
	
	m_vertexBufSz = vertexBufSz;
	m_indexBufSz = indexBufSz;

	m_pViewMatrix = NULL;
	m_pProjectionMatrix = NULL;

//BLENDݒ=====================================
	m_blend_enable = false;
	ZeroMemory(&m_BlendDesc, sizeof(D3D11_BLEND_DESC));
	m_BlendDesc.AlphaToCoverageEnable    = FALSE;
	m_BlendDesc.IndependentBlendEnable   = FALSE;
	m_BlendDesc.RenderTarget[0].BlendEnable           = TRUE;
	m_BlendDesc.RenderTarget[0].BlendOp               = D3D11_BLEND_OP_ADD;
	m_BlendDesc.RenderTarget[0].SrcBlend              = D3D11_BLEND_SRC_ALPHA;//D3D11_BLEND_ONE;
	m_BlendDesc.RenderTarget[0].DestBlend             = D3D11_BLEND_ONE;
	m_BlendDesc.RenderTarget[0].BlendOpAlpha          = D3D11_BLEND_OP_ADD;
	m_BlendDesc.RenderTarget[0].SrcBlendAlpha         = D3D11_BLEND_ZERO;
	m_BlendDesc.RenderTarget[0].DestBlendAlpha        = D3D11_BLEND_ZERO;
	m_BlendDesc.RenderTarget[0].RenderTargetWriteMask = D3D11_COLOR_WRITE_ENABLE_ALL;
//===============================================

//ގ̐Fݒ===================================
	m_ambient_color[0] = 1.0f;
	m_ambient_color[1] = 1.0f;
	m_ambient_color[2] = 1.0f;
	m_ambient_color[3] = 1.0f;
//

}


BasicRenderer::~BasicRenderer(){

	
	ID3D11BlendState* pBlendState = m_blend_master.find(m_BlendDesc);
	SAFE_RELEASE(pBlendState);

    SAFE_RELEASE(m_pVertexBuffer);
    SAFE_RELEASE(m_pIndexBuffer );
    SAFE_RELEASE(m_pWVPBuffer );
    
	//if( m_pVertexLayout ) m_pVertexLayout->Release();
    //if( m_pVertexShader ) m_pVertexShader->Release();
    //if( m_pPixelShader ) m_pPixelShader->Release();
	if( m_pVertexShader ) m_comShader->UnloadShader((LPVOID)m_pVertexShader);
	if( m_pPixelShader ) m_comShader->UnloadShader((LPVOID)m_pPixelShader);

}


HRESULT BasicRenderer::InitShader(){	//X[p[NXł͌Ă΂Ȃ
	TCHAR filepath[MAX_PATH];
	GetAttachedFileName(filepath, _T("resource\\shader02.fx"));

//Vertex Shader--------------------------------------
	UINT numElements = ARRAYSIZE( DX11LAYOUT_P3N3 );
	m_pVertexShader = m_comShader->LoadVertexShader(filepath, "VS", "vs_4_0", DX11LAYOUT_P3N3, numElements, &m_pVertexLayout);


//Pixel Shader-----------------------------------------
	m_pPixelShader = m_comShader->LoadPixelShader(filepath, "PS", "ps_4_0");

    
//------------------------------------------------------------
//Vertex buffer̍쐬.

	D3D11_BUFFER_DESC bd;
    bd.ByteWidth = m_vertexBufSz;
    bd.Usage = D3D11_USAGE_DEFAULT;
    bd.BindFlags = D3D11_BIND_VERTEX_BUFFER;
	bd.CPUAccessFlags = 0;
	bd.MiscFlags = 0;
	bd.StructureByteStride=0;

//lȂ
//  D3D11_SUBRESOURCE_DATA vertexSD;
//  vertexSD.pSysMem = pVertex;
//	vertexSD.SysMemPitch = 0;
//	vertexSD.SysMemSlicePitch = 0;
	

    HRESULT hr = m_dx11_core->pd3dDevice->CreateBuffer( &bd, NULL, &m_pVertexBuffer );
    if( FAILED( hr ) )
        return hr;

    // Set vertex buffer
//    m_vertex_stride = vertex_stride;
    //m_pd3dDC->IASetVertexBuffers( 0, 1, &m_pVertexBuffer, &vertex_stride, &offset );

//---------------------------------------------------------
//Index buffer̍쐬.

	bd.ByteWidth = m_indexBufSz;
    bd.Usage = D3D11_USAGE_DEFAULT;
    bd.BindFlags = D3D11_BIND_INDEX_BUFFER;
	bd.CPUAccessFlags = 0;
	bd.MiscFlags = 0;
	bd.StructureByteStride=0;
	
//lȂ
//	D3D11_SUBRESOURCE_DATA indexSD;
//  indexSD.pSysMem = pIndex;
//	indexSD.SysMemPitch = 0;
//	indexSD.SysMemSlicePitch = 0;

    hr = m_dx11_core->pd3dDevice->CreateBuffer( &bd, NULL, &m_pIndexBuffer );
    if( FAILED( hr ) )
        return hr;

//	if(index_stride == 2){
//		m_index_format = DXGI_FORMAT_R16_UINT;
//	}else{
//		m_index_format = DXGI_FORMAT_R32_UINT;
//	}



//-----------------------------------------------------------------------
//Constant buffer̍쐬
//constant bufferƂ́AJʒu⃏[hϊsȂ,
//CPUGPŮeXbhɃANZXobt@.
//[hs:fglobalԂɐݒuƂ̈ʒu(sړ)(])Zbgs.
//r[s:J猩Wn֕ϊ.
//ˉes:2W֕ϊ


	//projection, view, world matrixes
	bd.ByteWidth = sizeof( mat44f )*3 + sizeof(float)*4;
    bd.Usage = D3D11_USAGE_DYNAMIC;
    bd.BindFlags = D3D11_BIND_CONSTANT_BUFFER;
	bd.CPUAccessFlags = D3D11_CPU_ACCESS_WRITE;	//CPȔ
	bd.MiscFlags = 0;
	bd.StructureByteStride=0;
	//SUBRESOURCEɂ鏉l͐ݒ肵Ȃ

    hr = m_dx11_core->pd3dDevice->CreateBuffer( &bd, NULL, &m_pWVPBuffer );
    if( FAILED( hr ) )
        return hr;

	////Light position.
	//bd.ByteWidth = sizeof( float )*4;	
	//hr = pd3dDevice->CreateBuffer( &bd, NULL, &m_pLightBuffer );
 //   if( FAILED( hr ) )
 //       return hr;
	

	
    return S_OK;
}



void BasicRenderer::Draw(UINT index_count, vec3f* position){

	//ϊs
	mat44f world_matrix;
	world_matrix.SetIdentity();
	
	//world (position) matrix.
	world_matrix.m41 = position->x;
	world_matrix.m42 = position->y;
	world_matrix.m43 = position->z;


	//Blendݒ///////////////////////////////
	//ftHg̃uhXe[g.
	ID3D11BlendState*		org_pBlendState;
	FLOAT org_BlendFactor[4];
	UINT org_SampleMask;
	if(m_blend_enable){
		
		//BlendStateIuWFNgT.
		ID3D11BlendState* pBlendState = m_blend_master.find(m_BlendDesc);
		//BlendStateIuWFNg쐬ȂVK쐬
		if(pBlendState == NULL){
			HRESULT hr = m_dx11_core->pd3dDevice->CreateBlendState(&m_BlendDesc, &pBlendState);
			m_blend_master.add(m_BlendDesc, pBlendState);
		}
		//BlendStateIuWFNgݒ.
		if(pBlendState){
			m_dx11_core->pd3dDC->OMGetBlendState(&org_pBlendState, org_BlendFactor, &org_SampleMask);
			m_dx11_core->pd3dDC->OMSetBlendState(pBlendState, org_BlendFactor, org_SampleMask);
		}
	}
	//XeVݒ////////////////////////////////////
	//ftHg̃XeVXe[g.
//	ID3D11DepthStencilState*		org_pDepthStencilState;
//	UINT org_StencilRef;

	/////////////////////////////////////////////////

	// Set the input layout
    m_dx11_core->pd3dDC->IASetInputLayout( m_pVertexLayout );
	
    // Set primitive topology
    m_dx11_core->pd3dDC->IASetPrimitiveTopology( D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST );

	//萔obt@̏.
	D3D11_MAPPED_SUBRESOURCE mappedResource;
	m_dx11_core->pd3dDC->Map( m_pConstantBuffers[0], 0, D3D11_MAP_WRITE_DISCARD, 0,&mappedResource);
	CopyMemory(mappedResource.pData, &world_matrix, sizeof(mat44f));
	CopyMemory((float*)mappedResource.pData + 16, m_pViewMatrix, sizeof(mat44f));
	CopyMemory((float*)mappedResource.pData + 32, m_pProjectionMatrix, sizeof(mat44f));
	CopyMemory((float*)mappedResource.pData + 48, m_ambient_color, sizeof(float)*4);
	m_dx11_core->pd3dDC->Unmap( m_pConstantBuffers[0], 0);


	//obt@̃Zbg.	
    UINT offset = 0;
    m_dx11_core->pd3dDC->IASetVertexBuffers( 0, 1, &m_pVertexBuffer, &m_vertex_stride, &offset );
	m_dx11_core->pd3dDC->IASetIndexBuffer( m_pIndexBuffer, m_index_format, 0 );

    // Render materials
	m_dx11_core->pd3dDC->VSSetShader( m_pVertexShader, NULL, 0 );
	m_dx11_core->pd3dDC->VSSetConstantBuffers(0, 1, m_pConstantBuffers);
	
	
	m_dx11_core->pd3dDC->GSSetShader( NULL, NULL, 0 );
	//m_pd3dDC->GSSetConstantBuffers(0, 1, NULL);

	/*
		pd3dDC->PSSetShader( m_pPixelShader, NULL, 0 );
		g_pImmediateContext->PSSetShaderResources( 0, 1, &m_pTextureRVArray );
		g_pImmediateContext->PSSetSamplers( 0, 1, &m_pSampler );
	*/

	m_dx11_core->pd3dDC->PSSetShader( m_pPixelShader, NULL, 0 );	//Untex
	m_dx11_core->pd3dDC->PSSetConstantBuffers(0, 1, m_pConstantBuffers);

	m_dx11_core->pd3dDC->DrawIndexed( index_count, 0, 0);

	
	//Blendݒ///////////////////////////////
	if(m_blend_enable){
		m_dx11_core->pd3dDC->OMSetBlendState(org_pBlendState, org_BlendFactor, org_SampleMask);
	}

}


void BasicRenderer::UpdateVertexBuffer(LPVOID pBuffer, UINT count, UINT stride){
	
	if(count * stride > m_vertexBufSz){
		//obt@̍쐬ETCYύX

		//łɃobt@ꍇ͋LĂ,
		//Vobt@GPUɃZbgĂÂقRelease	
		ID3D11Buffer* m_pOldBuffer = NULL;
		if(	m_pVertexBuffer ){
			m_pOldBuffer = m_pVertexBuffer;
		}

		m_vertexBufSz = count * stride;
		
		D3D11_BUFFER_DESC bd;
		bd.ByteWidth = stride * count;
		bd.Usage = D3D11_USAGE_DEFAULT;		//D3D11_USAGE_DYNAMIC;
		bd.BindFlags = D3D11_BIND_VERTEX_BUFFER;
		bd.CPUAccessFlags = 0;				//D3D11_CPU_ACCESS_WRITE;
		bd.MiscFlags = 0;
		bd.StructureByteStride=0;

		HRESULT hr = m_dx11_core->pd3dDevice->CreateBuffer( &bd, NULL, &m_pVertexBuffer );
		if( FAILED( hr ) )
			return;
	
		if(m_pOldBuffer) m_pOldBuffer->Release();

	}///obt@̍쐬I

	if(pBuffer == NULL){//NULL̏ꍇ̓obt@쐬ďI.
		return;
	}

	UINT offset = 0;
    m_dx11_core->pd3dDC->IASetVertexBuffers( 0, 1, &m_pVertexBuffer, &stride, &offset );
	m_vertex_stride = stride;

	D3D11_BOX destRegion;
	destRegion.left = 0;
	destRegion.right = count * stride;
	destRegion.top = 0;
	destRegion.bottom = 1;
	destRegion.front = 0;
	destRegion.back = 1;
	m_dx11_core->pd3dDC->UpdateSubresource( m_pVertexBuffer, 0, &destRegion, pBuffer, 0, 0);
	//m_dx11_core->pd3dDC->UpdateSubresource( m_pVertexBuffer, 0, NULL, pBuffer, 0, 0);
}

void BasicRenderer::UpdateIndexBuffer(LPVOID pBuffer, UINT count, UINT stride){
	UINT offset = 0;
	if(stride == 2){
		m_index_format = DXGI_FORMAT_R16_UINT;
	}else{
		m_index_format = DXGI_FORMAT_R32_UINT;
	}

	
	if(count * stride > m_indexBufSz){
		//obt@̍쐬ETCYύX

		//łɃobt@ꍇ͋LĂ,
		//Vobt@GPUɃZbgĂÂقRelease	
		ID3D11Buffer* m_pOldBuffer = NULL;
		if(	m_pVertexBuffer ){
			m_pOldBuffer = m_pIndexBuffer;
		}

		m_indexBufSz = count * stride;
		
		D3D11_BUFFER_DESC bd;
		bd.ByteWidth = stride * count;
		bd.Usage = D3D11_USAGE_DEFAULT;		//D3D11_USAGE_DYNAMIC;
		bd.BindFlags = D3D11_BIND_INDEX_BUFFER;
		bd.CPUAccessFlags = 0;				//D3D11_CPU_ACCESS_WRITE;
		bd.MiscFlags = 0;
		bd.StructureByteStride=0;

		HRESULT hr = m_dx11_core->pd3dDevice->CreateBuffer( &bd, NULL, &m_pIndexBuffer );
		if( FAILED( hr ) )
			return;
	
		if(m_pOldBuffer) m_pOldBuffer->Release();

	}///obt@̍쐬I

	if(pBuffer == NULL){//NULL̏ꍇ̓obt@쐬ďI.
		return;
	}

	m_dx11_core->pd3dDC->IASetIndexBuffer( m_pIndexBuffer, m_index_format, 0 );
	//m_dx11_core->pd3dDC->UpdateSubresource( m_pIndexBuffer, 0, NULL, pBuffer, count * stride, count * stride);
	
	D3D11_BOX destRegion;
	destRegion.left = 0;
	destRegion.right = count * stride;
	destRegion.top = 0;
	destRegion.bottom = 1;
	destRegion.front = 0;
	destRegion.back = 1;
	m_dx11_core->pd3dDC->UpdateSubresource( m_pIndexBuffer, 0, &destRegion, pBuffer, 0, 0);
	//m_dx11_core->pd3dDC->UpdateSubresource( m_pIndexBuffer, 0, NULL, pBuffer, count * stride, count * stride);

}


void BasicRenderer::SetViewMatrixPointer(mat44f* pViewMatrix ){
	m_pViewMatrix = pViewMatrix;
}

void BasicRenderer::SetProjectionMatrixPointer(mat44f* pProjectionMatrix ){
	m_pProjectionMatrix = pProjectionMatrix;
}

void BasicRenderer::Enable(unsigned int param){
//e@\On/Off(OpenGL݊)
	switch(param){
	case DOG_BLEND:
		m_blend_enable = true;


		break;
	}

}

void BasicRenderer::Disable(unsigned int param){
//e@\On/Off(OpenGL݊)
	switch(param){
	case DOG_BLEND:
		m_blend_enable = false;



		break;
	}

}



D3D11_BLEND GLtoDXBlendFuncParam(unsigned int factor){
//BlendFuncp̈AOpenGLpDirectX11p֕ϊ.
	switch(factor){
	case DOG_ZERO:
		return D3D11_BLEND_ZERO;
	case DOG_ONE:
		return D3D11_BLEND_ONE;
	case DOG_SRC_COLOR:
		return D3D11_BLEND_SRC_COLOR;
	case DOG_ONE_MINUS_SRC_COLOR:
		return D3D11_BLEND_INV_SRC_COLOR;
	case DOG_SRC_ALPHA:
		return D3D11_BLEND_SRC_ALPHA;
	case DOG_ONE_MINUS_SRC_ALPHA:
		return D3D11_BLEND_INV_SRC_ALPHA;
	case DOG_DST_ALPHA:
		return D3D11_BLEND_DEST_ALPHA;
	case DOG_ONE_MINUS_DST_ALPHA:
		return D3D11_BLEND_INV_DEST_ALPHA;
	case DOG_DST_COLOR:
		return D3D11_BLEND_DEST_COLOR;
	case DOG_ONE_MINUS_DST_COLOR:
		return D3D11_BLEND_INV_DEST_COLOR;
	case DOG_SRC_ALPHA_SATURATE:
		return D3D11_BLEND_SRC_ALPHA_SAT;
	}
	return D3D11_BLEND_ZERO;
}

void BasicRenderer::BlendFunc(unsigned int sfactor, unsigned int dfactor){
//Blendݒ(OpenGL݊)
	m_BlendDesc.RenderTarget[0].SrcBlend = GLtoDXBlendFuncParam(sfactor);
	m_BlendDesc.RenderTarget[0].SrcBlendAlpha = m_BlendDesc.RenderTarget[0].SrcBlend;

	m_BlendDesc.RenderTarget[0].DestBlend = GLtoDXBlendFuncParam(dfactor);
	m_BlendDesc.RenderTarget[0].DestBlendAlpha = m_BlendDesc.RenderTarget[0].DestBlend;

}


bool IsEqual(D3D11_BLEND_DESC a, D3D11_BLEND_DESC b){
	if(a.AlphaToCoverageEnable != b.AlphaToCoverageEnable){return false;}
	if(a.IndependentBlendEnable != b.IndependentBlendEnable){return false;}
	for(int i = 0; i < 8; i++){
		if(a.RenderTarget[i].BlendEnable != b.RenderTarget[i].BlendEnable){return false;}
		if(a.RenderTarget[i].BlendOp != b.RenderTarget[i].BlendOp){return false;}
		if(a.RenderTarget[i].BlendOpAlpha != b.RenderTarget[i].BlendOpAlpha){return false;}
		if(a.RenderTarget[i].DestBlend != b.RenderTarget[i].DestBlend){return false;}
		if(a.RenderTarget[i].DestBlendAlpha != b.RenderTarget[i].DestBlendAlpha){return false;}
		if(a.RenderTarget[i].RenderTargetWriteMask != b.RenderTarget[i].RenderTargetWriteMask){return false;}
		if(a.RenderTarget[i].SrcBlend != b.RenderTarget[i].SrcBlend){return false;}
		if(a.RenderTarget[i].SrcBlendAlpha != b.RenderTarget[i].SrcBlendAlpha){return false;}
	}
	return true;
};


void BasicRenderer::Materialfv(unsigned int face, unsigned int pname, float* rgba){
//(OpenGL݊)
//CgƂ̐Fݒ
	switch (pname){
	case DOG_AMBIENT:
	case DOG_AMBIENT_AND_DIFFUSE:
		memcpy(m_ambient_color, rgba, sizeof(float)*4);
		break;
	}

}



//exeƓtH_ɂt@CpX֒.
int GetAttachedFileName(TCHAR* filepath, const TCHAR *filename){
	//TCHAR filepath[MAX_PATH];
	int length = GetModuleFileName(NULL, filepath, MAX_PATH);
	if(length <= 0){ return -1;}

	TCHAR* p = _tcsrchr(filepath, _T('\\'));
	if(! p ) { return -1;}

	_tcscpy(p + 1, filename);
	return 0;
}