#ifndef __celldiv_h__
#define __celldiv_h__

//#include <stdlib.h>
//#include <tchar.h>

#include "vec3.h"
#include "mat33.h"
#include "mod.h"
#include "debugprint.h"


struct CELLDIV_INFO{
	int cellall;	//cell̑
	int* first_in_cell;	//cellɓĂ擪̗qԍ.
	int* cell_pair;	//qyATcell̑gݍ킹.
	int* inext;		//index̗qƓcellɓĂ鎟̗qԂ.
	union{
		int cell_pair_index[12];
		struct{
			int non_periodic;
			int periodic_x2;
			int periodic_y2;
			int periodic_z2;
			int periodic_xy2;
			int periodic_x1_y2;
			int periodic_yz2;
			int periodic_y1_z2;
			int periodic_zx2;
			int periodic_z1_x2;
			int periodic_xyz;
		};
	};
};

class CellDiv{
protected:
	int m_max_count;	//肦ő嗱q

	vec3d m_box;
	vec3d m_boxi;
	mat33d m_Am;		//sim.box̎e\(a, b, c).

	int m_mcell;
	
	int* m_inext;		//index̗qƓcellɓĂ鎟̗qԂ.

	int* m_first_in_cell;	//cellɓĂ擪̗qԍ.

	int* m_cell_pair;	//qyATcell̑gݍ킹.
	int m_cell_pair_index[12];	//cell̑gݍ킹̎ޖ̃[vp̐擪CfbNX.
//0: EׂȂZ̑g݂̐擪ʒu.
//1: xEׂZ̑g݂̐擪ʒu.
//2: yEׂZ̑g݂̐擪ʒu.
//3: zEׂZ̑g݂̐擪ʒu.
//4: ҂̃ZxyEׂZ̑g݂̐擪ʒu.
//5: O҂xzcell,҂yzcell̑g݂̐擪ʒu.
//6: ҂yzɉzcell.
//7: O҂yzcell,҂zzcell.
//8: ҂zxɉzcell.
//9: O҂zzcell,҂xzcell.
//10: ExyzEɌׂꍇ.
//11: Z̑gݍ킹̑.

private:
	double m_cellwidth;
	int m_periodic_flag;
	int m_mx;
	int m_my;
	int m_mz;
	

//	int* m_cycle_x;
//	int* m_cycle_y;
//	int* m_cycle_z;

	void InitCell(int a_mcx, int a_mcy, int a_mcz);
	
	
public:
	

	CellDiv(double cellwidth, int periodic_flag, int maxcount);
	virtual ~CellDiv();
	
	
	void SetCellSize(double cellsize, int periodic_flag);
	void SetBoxsize(double x, double y, double z);
	void SetBoxAxis(vec3d a, vec3d b, vec3d c);
	void SetBoxAxis(mat33d Am);
	//mat33d GetBoxAxis();

	
	void PutIntoCell(int count, vec3d* r, int* knd);
	void PutIntoCellNonortho(int count, vec3d* r, int* knd);	//csim.boxp.

	int GetCellInfo(CELLDIV_INFO* celldiv_info);
	
};


#define FLAG_PERIODIC_X		(0x1)
#define FLAG_PERIODIC_Y		(0x2)
#define FLAG_PERIODIC_Z		(0x4)
#define FLAG_PERIODIC_XY	(0x3)
#define FLAG_PERIODIC_YZ	(0x6)
#define FLAG_PERIODIC_ZX	(0x5)
#define FLAG_PERIODIC_XYZ	(0x7)


#endif    // __celldiv_h__
