
#define WIN32_LEAN_AND_MEAN             // Windows wb_[gpĂȂO܂B
#include <windows.h>
#include <tchar.h>
#include <math.h>

#include "eventGL15.h"
#include "ai_funcs.h"
#include "ai_molecule.h"
//#include "MDLoader.h"
//#include "AtomRendererGL.h"
//#include "Field3DLoader.h"
//#include "trajectory.h"
#include "camera.h"
#include "filelist.h"

#include "ai_graphic.h"
#include "windib2.h"

#include "debugprint.h"


//extern CAMERA_INFO cam_info;
//extern MDLoader* atm;
//extern AtomRendererGL* renderer;
//extern Field3DLoader* g_field;
//extern int visibleMode;
extern float bgcolor_reset[4];
extern int g_visual_box;
extern int AutoBMP;

extern CameraGL* g_camera;
extern int g_projection_mode;

extern int g_timeframe;


extern int g_visual_atom;
extern int g_visual_atompoly;
extern double g_visual_atomradius;
extern int g_visual_atomcolor; 
extern int g_visual_bond;
extern int g_visual_bondpoly;
extern int g_visual_traj;


static float* g_geoVertex = NULL;
static int g_geoVertexCount = 0;
static int* g_geoIndex = NULL;
static int g_geoIndexCount = 0;

static float* vbo_vertex = NULL;
static int vbo_vertex_count = 0;
static int* vbo_index = NULL;
static int vbo_index_count = 0;

static ATOMS_DATA* m_prev_render_dat;

void CopyInstanceVertex(float* geoVertex, int geoVertexCount, int geoVertexStride, float* positions, int count, float **ppVertex, int *pVertexCount, int **ppIndex, int *pIndexCount);

void RenderingPartGL15(MasterFileList* files);

void InitGL15(void){
	glClearColor(0.0, 0.0, 0.0, 0.0);
	
	glShadeModel(GL_SMOOTH);/*VF[fBO[h,GL_SMOOTH or GL_FLAT */
	glEnable(GL_DEPTH_TEST);/* fvXobt@(zobt@)gp */
	glClearDepth( 1.0 );/* fvXobt@(zobt@)NAl*/

	glEnable(GL_LIGHTING);/*gp*/
	glEnable(GL_LIGHT0);/*gp*/
	glEnable(GL_NORMALIZE);/* @vZ𐳋K */

	glEnable(GL_CULL_FACE);/*JOs*/
	glCullFace(GL_BACK);/*wʂ\Ȃ*/


	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity(); /* fOs̏ */


}

void DisplayGL15(MasterFileList* files, int wnd_w, int wnd_h){
			//`ƍĕ`掞ɌĂ΂B
			//resizeĕ`悳̂ŌĂ΂Bresize -> display̏


	//ˉeϊ̐ݒ===================================//
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	if(g_projection_mode){
		double distance = g_camera->GetForcusDistance();
		double top = distance * tan(20.0 * PI / (180.0 * 2.0));
		double right = top * (double)wnd_w / (double)wnd_h;
		glOrtho(-right, right, -top, top, 5.0,max(distance * 2.0,10000.0));
	}else{
		double nearlen = 10.0;
		double top = nearlen * tan(20.0 * PI / (180.0 * 2.0));
		double right = top * (double)wnd_w / (double)wnd_h;
		glFrustum(-right, right, -top, top, nearlen, 10000.0);
	}
	//===================================ˉeϊ//

	RenderingPartGL15(files);
}

void RenderingPartGL15(MasterFileList* files){

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	//CgݒglMatrixMode(GL_MODELVIEW)̌ɏȂΗLɂȂȂ//
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	//ʂwiFŃNA
	const GLfloat lva[] = {0.4f, 0.4f, 0.4f,1.0f};
	const GLfloat lvp[] = {0.0f, 0.0f, 10.0f,0.0f};
	//Cg̐ݒ
	glLightfv(GL_LIGHT0, GL_AMBIENT, lva);
	glLightfv(GL_LIGHT0, GL_POSITION, lvp);
		//GL_POSITION̑4p[^0͕̎s,0ȊOł͓_



	g_camera->SetGLCamera();

	//visual setting//
	VISUAL_SETTING vis;
	vis.atom = g_visual_atom;
	vis.atom_poly = g_visual_atompoly;
	vis.atom_radius = g_visual_atomradius;
	vis.bond = g_visual_bond;
	vis.bond_poly = g_visual_bondpoly;


	for(FileList* fi = files->first; fi != NULL; fi = fi->next){

		switch(fi->type){
		case FILETYPE_ATOM:
			{			   

				ATOMS_DATA* dat = fi->atm->GetDataPointer();

				fi->atomRenderer->Rendering(dat, &vis);

				if(g_visual_box){
					//AI_setBoundary(-dat->boxx*0.5f, -dat->boxy*0.5f, -dat->boxz*0.5f, dat->boxx*0.5f, dat->boxy*0.5f, dat->boxz*0.5f);
					AI_setSimBox(&(dat->boxaxis), &(dat->boxorg));
				}


				glFlush();

			}
			break;
		case FILETYPE_TRAJ:

			glLineWidth(2.0f);


			fi->bca->Rendering();

			if(g_visual_box){
				vec3f boxsize, boxorg;
				fi->bca->GetBoxsize(&boxsize, &boxorg);
				if(fabs(boxsize.x) > 1.0e-5){
					AI_setBoundary(boxorg.x, boxorg.y, boxorg.z, boxorg.x + boxsize.x, boxorg.y + boxsize.y, boxorg.z + boxsize.z);
				}
			}
			glFlush();
			glLineWidth(1.0f);
			break;
			
		case FILETYPE_FIELD:
			{
		
			glDisable(GL_LIGHTING);
			//fi->field->Create3DTexture();
			vec3d target;
			vec3d camera;
			g_camera->GetDirection(&target, &camera);
			fi->field->SetMaterial(&target, &camera);
			
			
			if(g_visual_box){
				mat33f boxaxis; 
				vec3f boxorg;
				fi->field->GetBoxaxis(&boxaxis, &boxorg);
				AI_setSimBox(&boxaxis, &boxorg);
				
			}
			glFlush();
			glEnable(GL_LIGHTING);
			}
			break;
		
		case FILETYPE_LMC:
			{
		
			vec3d target;
			vec3d camera;
			g_camera->GetDirection(&target, &camera);
			
			int grid_x, grid_y, grid_z;
			fi->lmc->GetNumGrid(&grid_x, &grid_y, &grid_z);
			int num_elements = fi->lmc->GetNumElements();

			mat33f boxaxis; 
			vec3f boxorg;
			fi->lmc->GetBoxaxis(&boxaxis, &boxorg);

			LMC_INT* dat = fi->lmc->GetDataPointer();
			
			fi->lmcRenderer->Rendering(dat, grid_x, grid_y, grid_z, num_elements, (float*)&boxaxis, &vis, g_timeframe);
			
			
			if(g_visual_box){
				AI_setSimBox(&boxaxis, &boxorg);
				
			}
			glFlush();
			}
			break;
		
		}		
	}


	return;
	
}


void CopyInstanceVertex(float* geoVertex, int geoVertexCount, int geoVertexStride, float* positions, int count, float **ppVertex, int *pVertexCount, int **ppIndex, int *pIndexCount){

	int snum = 6;
	int stride = snum * sizeof(float);
	float *buffer = *ppVertex;

	for(int k = 0; k < count * 3; k+=3){
		
		for(int i = 0; i < geoVertexCount * snum; i += snum){ 
			memcpy(buffer + i, geoVertex, stride);
			buffer[i] += positions[k];
			buffer[i+1] += positions[k+1];
			buffer[i+2] += positions[k+2];
		}
		buffer += geoVertexCount * snum;
	}
	
}



void InitSphereGeometry(float radius, int slices, int stacks, float **ppVertex, int *pVertexCount, int **ppIndex, int *pIndexCount){
	
	const int snum = 6;

	int i, k;
	double daXY = 2.0*PI/double(stacks);
	double daZX = PI/double(slices);
	double angleZX;
	double angleXY;
	float cosZX, sinZX;
	float *cosXY, *sinXY;
	

	
	cosXY = new float[stacks];
	sinXY = new float[stacks];
	
	angleXY = daXY;
	cosXY[0] = 1.f;
	sinXY[0] = 0.f;
	for (i = 1; i < stacks; i++){
		cosXY[i] = (float)cos(angleXY);
		sinXY[i] = (float)sin(angleXY);
		angleXY += daXY;
	}

	int vertexCount = ((slices - 1) * stacks + 2);
	*ppVertex = new float[vertexCount * snum];
	//vec3f *nor = m_sphere_nor = new vec3f[m_sphere_vcnt];


	vec3f *pos = (vec3f*)(*ppVertex);
	vec3f *nor = (vec3f*)(vertexCount + 3);
	pos->Set(0.0f,0.0f,(float)radius);
	nor->Set(0.0f, 0.0f, 1.0f);

	angleZX = daZX;
	for (i = 1; i < slices; i++){
		cosZX = (float)cos(angleZX);
		sinZX = (float)sin(angleZX);

		for (k = 0; k < stacks; k++){
	
			pos = (vec3f*)(*ppVertex + k + i * stacks);
			nor = (vec3f*)(*ppVertex + k + i * stacks + 3);
	
			nor->Set(sinZX * cosXY[k], sinZX * sinXY[k], cosZX);
			pos->x = nor->x * radius;
			pos->y = nor->y * radius;
			pos->z = nor->z * radius;

		}
		angleZX += daZX;
	}
	
	pos = (vec3f*)(*ppVertex + k + i * stacks);
	nor = (vec3f*)(*ppVertex + k + i * stacks + 3);

	nor->Set(0.0f, 0.0f, -1.0f);
	pos->Set(0.0f,0.0f, -radius);
	
	delete [] cosXY;
	delete [] sinXY;


	//CfbNXz̃Zbg
	int indexCount = (slices - 1)*stacks*6;
	int* idx = *ppIndex = new int[indexCount];
	int offset = 1;
	for(i=0; i < stacks; i++){
		*idx = 0;
		idx++;
		*idx = i + offset;
		idx++;
		*idx = ((i + 1) % stacks) + offset;
		idx++;
	}
	//offset += stacks;
	
	
	for (k = 0; k < slices - 2; k++){
		for(i=0; i < stacks; i++){
			*idx = i + offset;
			idx++;
			*(idx + 3) = *idx = i + offset + stacks;
			idx++;
			*(idx + 1) = *idx = ((i + 1) % stacks) + offset;
			idx+=3;
			*idx = ((i + 1) % stacks) + offset + stacks;
			idx++;
		}
		offset += stacks;
	}

	for(i=0; i < stacks; i++){
		*idx = i + offset;
		idx++;
		*idx = vertexCount - 1;
		idx++;
		*idx = ((i + 1) % stacks) + offset;
		idx++;
	}

	*pVertexCount = vertexCount;
	*pIndexCount = indexCount;

};


//݂̉摜𐔔{TCYŏo
void OutputBMfromGLMag(MasterFileList* files, TCHAR *fName, int magnify){
	
	int size_Color = 3;	
	FILE *fp;
	//BITMAPINFOHEADER bmih;
	
	GLint viewport[4];//x,y,w,h in viewport.
	
	fp = _tfopen(fName,_T("wb"));
	if (!fp){
		printf("bmpt@C̍쐬Ɏs܂\n");
		return;
	}
	

	glGetIntegerv(GL_VIEWPORT,viewport);//get viewport.
	
	glPixelStorei( GL_PACK_ALIGNMENT, 4);
		/*f[^]4byteɃZbgB32bitƂ̂B
	      ]ȕ0Ŗ߂BDIBdlȂ̂ł傤Ǘǂ*/
	
	//If using double buffer, select source to read pixels.
	//By default, mode is GL_FRONT in single-buffered configurations,
	//and GL_BACK in double-buffered configurations.
	glReadBuffer(GL_BACK);

	int line_size = viewport[2] * size_Color;
	if (line_size % 4){	line_size += 4 - (line_size % 4);}
	BYTE *bmBuf = new BYTE[line_size * viewport[3]];

	int all_line_size = viewport[2] * size_Color * magnify;
	if (all_line_size % 4){	all_line_size += 4 - (all_line_size % 4);}
	BYTE *allBuf = new BYTE[all_line_size * viewport[3] * magnify];
	
	double ss = tan(20.0 * PI / (180.0 * 2.0));
	double top = ss * 10.0;
	double right = top * (double)viewport[2] / (double)viewport[3];

	double dh = top * 2.0 / (double)magnify;
	double dw = right * 2.0 / (double)magnify;

	glLineWidth((float)magnify);

	
	int x, y;
	int offset_y = 0;
	double btm = -top;

	for (y = 0; y < magnify; y++){
		int offset_x = 0;
		double left = - right;
		for (x = 0; x < magnify; x++){


			//ˉeϊ(ʏTCYƈقȂ)//
			glMatrixMode(GL_PROJECTION);
			glLoadIdentity();		
			glFrustum(left, left + dw, btm, btm + dh, 10.0,2000.0);
			//=======================================ˉeϊ//


			RenderingPartGL15(files);

			glReadPixels(
				viewport[0], viewport[1],               // Jn_
				viewport[2], viewport[3],                // ǂݎTCY
				GL_BGR,             // ǂݎ`ݒ(verႢƓȂ)
				GL_UNSIGNED_BYTE,                  // ۑ̃|C^̌^ 
				bmBuf                 // ۑ̔z̃|C^
			);

			int k;
			for(k = 0; k < viewport[3]; k++){
				memcpy(allBuf + offset_y + offset_x + k * all_line_size,
						bmBuf + k * line_size,
						viewport[2] * size_Color);
			}
					
			offset_x += viewport[2] * size_Color;
			left += dw;
		}
		offset_y += all_line_size * viewport[3];
		btm += dh;
	}

	delete [] bmBuf;
	
	writeDIB24(fp, viewport[2] * magnify, viewport[3] * magnify, allBuf);

	
	delete [] allBuf;
	fclose(fp);

	glLineWidth(1.0f);
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glFrustum(-right, right, -top, top, 10.0,2000.0);
}
