/*=====================================================


//WM_COMMAND̏//


=======================================================*/


#define _CRT_SECURE_NO_DEPRECATE
#include "winmain.h"
#include <shellapi.h>

#include "MDLoader.h"
#include "filelist.h"
#include "ai_molecule.h"
#include "ai_gr.h"
#include "ai_funcs.h"
#include "epsrender.h"
#include "mbsdup.h"
#include "md3_writer.h"
#include "eventGL15.h"

//plugin
#include "plugTDDepth.h"
#include "plugTDCoordinate.h"
#include "plugSSCoordinate.h"


extern HINSTANCE g_hInst;					// ݂̃CX^X

extern MasterFileList g_files;		//Jt@C̃Xg.
extern bool g_renderingLock;	//_OȂ悤LockB]Ȃ.
extern CameraGL* g_camera;
extern int g_projection_mode;
extern float bgcolor_reset[4];
extern int g_visual_atom;
extern int g_visual_atomcolor; 
extern int g_visual_bond;
extern int g_visual_traj;
extern int g_visual_atompoly;
extern int g_visual_bondpoly;
extern double g_visual_trajparticleRadius;
extern float g_visual_trajcolor[3];
extern int g_visual_box;

extern int g_timeframe;
extern int g_frameskip;	//step number of frame skip
extern int g_iFPS;	//seconds per frame
extern int g_movie;
extern int g_movie_mode;
extern int g_timerID;

extern int g_gpu_DX11;

extern int g_client_w;
extern int g_client_h;
extern int outNum;
extern double g_stereo_eyelength;
extern int g_vsync_mode;



void RecheckMenuFrameSkip(HMENU hmenu, int wmId);
void RecheckMenuMovieMode(HMENU hmenu, int wmId);
void EnableMovieCheckPoint(HWND hWnd, int flag);
void RecheckMenuShapeAtom(HMENU hmenu);
void RecheckMenuShapeBond(HMENU hmenu);
void RecheckMenuAtomColor(HMENU hmenu);
void RecheckMenuBoxFrame(HMENU hmenu, int index);
void RecheckMenuProjection(HMENU hmenu, int index);

void RecheckMenuBGColor(HMENU hmenu, int wmId);
LRESULT CALLBACK	About( HWND, UINT, WPARAM, LPARAM );
int LoadSettingFile(const TCHAR* filename);


void OutputSequentialStereoBMP(HWND hWnd);
void OutputSequentialBMP(HWND hWnd);
void OutputStereoBMP(HWND hWnd);

LRESULT CALLBACK WinCommand(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam){
	TCHAR spath[MAX_PATH];
	int wmId    = LOWORD(wParam); 
	int wmEvent = HIWORD(wParam); 
	ATOMS_DATA* dat;
	FileList* current = g_files.current;
	int length;


	// j[Ỉ:
	switch( wmId ) {

	case IDM_ABOUT:
		DialogBox(g_hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
		break;
	case IDM_EXIT:
		DestroyWindow( hWnd );
		break;

	case IDM_FILE_OPEN:
		{
			g_renderingLock = true;

			OPENFILENAME ofn;
			TCHAR szFile[ MAX_PATH ] = _T("");
			ZeroMemory( &ofn, sizeof( ofn ) );
			ofn.lStructSize = sizeof( OPENFILENAME );
			ofn.lpstrFilter = TEXT("Fortran`qWf[^(*.fad)\0*.fad\0")
								TEXT("oCiqWf[^(*.dat)\0*.dat\0")
								TEXT("XYZqWf[^(*.xyz)\0*.xyz\0")
								TEXT("PDBqWf[^(*.pdb)\0*.pdb\0")
								TEXT("gWFNg[f[^(*.txt)\0*.txt\0")
								TEXT("cubef[^(*.cube)\0*.cube\0")
								TEXT("SĂ̌`(*.*)\0*.*\0\0");
			//if( g_filename ){
			//	_tcscpy(szFile, g_filename );
			//}
			ofn.lpstrFile = szFile;
			ofn.nMaxFile = MAX_PATH;
			ofn.Flags = OFN_FILEMUSTEXIST;
			ofn.lpstrInitialDir = _T("");
			ofn.lpstrTitle = _T("f[^t@CIĂ");

			if (GetOpenFileName ( &ofn ) ){

				FileList* finfo = g_files.Add();
				OpenDataFile( szFile , finfo, g_camera);
				ResetCurrentFileMenu(hWnd, g_files.current);
				ResetWindowText(hWnd);
				InvalidateRect(hWnd, NULL, FALSE);
			}
			g_renderingLock = false;
		}
		break;

//S̋ʂ̐ݒ////////////////////////////////////
	//ˉe@̕ύX.
		
	case IDM_PROJECTION_PERSE:
		g_projection_mode = 0;
		RecheckMenuProjection(GetMenu(hWnd), g_projection_mode);
		InvalidateRect(hWnd, NULL, FALSE);
		break;
	case IDM_PROJECTION_ORTHO:
		g_projection_mode = 1;
		RecheckMenuProjection(GetMenu(hWnd), g_projection_mode);
		InvalidateRect(hWnd, NULL, FALSE);
		break;
	//wiF.
	case IDM_BGCOLOR_BLACK:
		bgcolor_reset[0] = 0.0f;
		bgcolor_reset[1] = 0.0f;
		bgcolor_reset[2] = 0.0f;
		bgcolor_reset[3] = 1.0f;
		
		RecheckMenuBGColor(GetMenu(hWnd), wmId);
		InvalidateRect(hWnd, NULL, FALSE);
		break;
	case IDM_BGCOLOR_WHITE:
		bgcolor_reset[0] = 1.0f;
		bgcolor_reset[1] = 1.0f;
		bgcolor_reset[2] = 1.0f;
		bgcolor_reset[3] = 1.0f;
		RecheckMenuBGColor(GetMenu(hWnd), wmId);
		InvalidateRect(hWnd, NULL, FALSE);
		break;
	//{bNX̕`.
	case IDM_BOXFRAME_ON:
		g_visual_box = 1;
		RecheckMenuBoxFrame(GetMenu(hWnd), g_visual_box);
		InvalidateRect(hWnd, NULL, FALSE);
		break;
	case IDM_BOXFRAME_OFF:
		g_visual_box = 0;
		RecheckMenuBoxFrame(GetMenu(hWnd), g_visual_box);
		InvalidateRect(hWnd, NULL, FALSE);
		break;
		
//qqp̋@\////////////////////////////
//̍Ĕ
	case IDM_RESET_BOND:
		if(g_movie){
			printf("Prease stop movie.\n");
			break;
		}
		
		AI_ResetBond(current->atm->GetDataPointer());
		current->atomRenderer->ClearVRAM();
		
		
		InvalidateRect(hWnd, NULL, FALSE);

		break;
//\`̐ݒ
	case IDM_SHAPE_SPHERE:
		g_visual_atom = VISUAL_ATOM_SPHERE;
//		current->atomRenderer->SetMode(VISUAL_TYPE_ATOM, g_visual_atom, current->atm->GetDataPointer());
		RecheckMenuShapeAtom(GetMenu(hWnd));
		InvalidateRect(hWnd, NULL, FALSE);
		break;
/*	case IDM_SHAPE_SPHERE_LARGE:
		g_visual_atom = VISUAL_ATOM_LARGE;
		current->atomRenderer->SetMode(VISUAL_TYPE_ATOM, g_visual_atom, current->atm->GetDataPointer());
		RecheckMenuShapeAtom(GetMenu(hWnd));
		InvalidateRect(hWnd, NULL, FALSE);
		break;
*/
	case IDM_SHAPE_POINT:
		g_visual_atom = VISUAL_ATOM_POINT;
//		current->atomRenderer->SetMode(VISUAL_TYPE_ATOM, g_visual_atom, current->atm->GetDataPointer());
		RecheckMenuShapeAtom(GetMenu(hWnd));
		InvalidateRect(hWnd, NULL, FALSE);
		break;
	case IDM_SHAPE_ATOM_NONE:
		g_visual_atom = VISUAL_ATOM_NONE;
//		current->atomRenderer->SetMode(VISUAL_TYPE_ATOM, g_visual_atom, current->atm->GetDataPointer());
		RecheckMenuShapeAtom(GetMenu(hWnd));
		InvalidateRect(hWnd, NULL, FALSE);
		break;
	case IDM_SHAPE_PIPE:
		g_visual_bond = VISUAL_BOND_PIPE;
//		current->atomRenderer->SetMode(VISUAL_TYPE_BOND, g_visual_bond, current->atm->GetDataPointer());
		RecheckMenuShapeBond(GetMenu(hWnd));
		InvalidateRect(hWnd, NULL, FALSE);
		break;
	//case IDM_SHAPE_ENERGYJ:
	//	g_visual_bond = VISUAL_BOND_ENERGYJ;
	//	current->atomRenderer->SetMode(VISUAL_TYPE_BOND, g_visual_bond, current->atm->GetDataPointer());
	//	RecheckMenuShapeBond(GetMenu(hWnd));
	//	InvalidateRect(hWnd, NULL, FALSE);
	//	break;
	case IDM_SHAPE_BOND_NONE:
		g_visual_bond = VISUAL_BOND_NONE;
//		current->atomRenderer->SetMode(VISUAL_TYPE_BOND, g_visual_bond, current->atm->GetDataPointer());
		RecheckMenuShapeBond(GetMenu(hWnd));
		InvalidateRect(hWnd, NULL, FALSE);
		break;
	
	case IDM_COLOR_ATOMIC:
		g_visual_atomcolor = VISUAL_ATOMCOLOR_Z;
		current->atomRenderer->SetMode(VISUAL_TYPE_ATOMCOLOR, g_visual_atomcolor, current->atm->GetDataPointer());
		RecheckMenuAtomColor(GetMenu(hWnd));
		InvalidateRect(hWnd, NULL, FALSE);
		break;
	case IDM_COLOR_BONDNUM:
		g_visual_atomcolor = VISUAL_ATOMCOLOR_BONDNUM;
		current->atomRenderer->SetMode(VISUAL_TYPE_ATOMCOLOR, g_visual_atomcolor, current->atm->GetDataPointer());
		RecheckMenuAtomColor(GetMenu(hWnd));
		InvalidateRect(hWnd, NULL, FALSE);
		break;

//1t[̉//////////////////////////////////
	//qɕ
	case IDM_CLASSIFYMOL:
		//if(atm==NULL){ break;}
		if(g_movie){
			printf("Prease stop movie.\n");
			break;
		}
		
		length = current->ext - current->filepath - 1;
		_tcsncpy(spath, current->filepath, length);
		_tcscpy(spath + length,_T("_mol.txt"));
		AI_WriteClassifyMolecule(current->atm->GetDataPointer(), spath);
		
		break;

	//az֐g(r)
	case IDM_RADIALDISTFUNC:
		//if(atm==NULL){ break;}

		dat = current->atm->GetDataPointer();
		//test------
		AI_eraceBulk(dat, dat->boxaxis.m33 * 0.5f - 75.0f);
		//----test

		length = current->ext - current->filepath - 1;
		_tcsncpy(spath, current->filepath, length);
		_stprintf(spath + length,_T("_gr%d.txt"), dat->no);
		
		WriteRadialDistFunc(0.02, dat, spath);
		
		break;

	//xz(r)
	case IDM_DENCITY:
		//if(atm==NULL){ break;}
		if(g_movie){
			printf("Prease stop movie.\n");
			break;
		}

		dat = current->atm->GetDataPointer();
		
	
		length = current->ext - current->filepath - 1;
		_tcsncpy(spath, current->filepath, length);
		_stprintf(spath + length,_T("_dencity%d.txt"), dat->no);
		
		WriteDencity( dat, spath,dat->boxaxis.m33 * 0.5f , -dat->boxaxis.m33 * 0.5f);

		break;

	//{ho
	case IDM_COORDINATE:
		//if(atm==NULL){ break;}
		if(g_movie){
			printf("Prease stop movie.\n");
			break;
		}

		dat = current->atm->GetDataPointer();
		
		plugFrameSS_Coordinate(current->filepath, current->dirlen, dat);

		break;
	
	//{ḧٕ.
	case IDM_BONDDIR:
		//if(atm==NULL){ break;}
		if(g_movie){
			printf("Prease stop movie.\n");
			break;
		}

		dat = current->atm->GetDataPointer();
		
		
		length = current->ext - current->filepath - 1;
		_tcsncpy(spath, current->filepath, length);
		_stprintf(spath + length,_T("_bonddir%d.txt"), dat->no);
		
		WriteBondDirection( dat, spath);

		break;

	//sp2̖@o
	case IDM_SP2NORMAL:
		//if(atm==NULL){ break;}
		if(g_movie){
			printf("Prease stop movie.\n");
			break;
		}

		dat = current->atm->GetDataPointer();
		
		
		length = current->ext - current->filepath - 1;
		_tcsncpy(spath, current->filepath, length);
		_stprintf(spath + length,_T("_sp2nor%d.txt"), dat->no);
		
		WriteSp2normal( dat, spath);

		break;



	//CƌH̒o.
	case IDM_HBOUNDC:
		//if(atm==NULL){ break;}

		if(g_movie){
			printf("Prease stop movie.\n");
			break;
		}

		dat = current->atm->GetDataPointer();
		
		
		length = current->ext - current->filepath - 1;
		_tcsncpy(spath, current->filepath, length);
		_stprintf(spath + length,_T("_absorbedH%d.txt"), dat->no);
		
		WriteBoundAtom(dat, g_frameskip, spath, KIND_H, KIND_C);
		
		InvalidateRect(hWnd, NULL, FALSE);
		break;

//n//////////////////////////////////
	case IDM_TD_COORDINATE:
		//if(atm==NULL){ break;}

		plugReadyTD_Coordinate(current->filepath, current->dirlen);
		
		dat = current->atm->GetDataPointer();
		while(dat){

			plugFrameTD_Coordinate(dat);

			if(g_frameskip > 1){
				if (current->atm->goNext(g_frameskip) == 0){
					break;
				}
			}else{		
				if (current->atm->goNext() == 0){
					break;
				}
			}
			dat = current->atm->GetDataPointer();
		}


		plugFinishTD_Coordinate(dat);

		ResetWindowText(hWnd);
		InvalidateRect(hWnd, NULL, FALSE);
		break;

	case IDM_TD_DEPTH:
		//if(atm==NULL){ break;}

		plugReadyTD_Depth(current->filepath, current->dirlen);
		
		dat = current->atm->GetDataPointer();
		while(dat){

			plugFrameTD_Depth(dat);

			if(g_frameskip > 1){
				if (current->atm->goNext(g_frameskip) == 0){
					break;
				}
			}else{		
				if (current->atm->goNext() == 0){
					break;
				}
			}
			dat = current->atm->GetDataPointer();
		}


		plugFinishTD_Depth(dat);

		ResetWindowText(hWnd);
		InvalidateRect(hWnd, NULL, FALSE);
		break;

	//fz(TIME-DEPENDENT)
	case IDM_ADSORBED_H_TD:
		//if(atm==NULL){ break;}

		
		length = current->ext - current->filepath - 1;
		_tcsncpy(spath, current->filepath, length);
		_tcscpy(spath + length,_T("_adsH.txt"));

		AI_WriteAdsorbedH( current->atm, g_frameskip,spath);
		
		ResetWindowText(hWnd);
		InvalidateRect(hWnd, NULL, FALSE);
		break;

	case IDM_RADIALDISTFUNC_PEAK_TD:
		//if(atm==NULL){ break;}

		length = current->ext - current->filepath - 1;
		_tcsncpy(spath, current->filepath, length);
		_tcscpy(spath + length,_T("_grtime.txt"));

		WriteRadialDistFuncMax(0.02, current->atm, g_frameskip,spath);
		
		ResetWindowText(hWnd);
		InvalidateRect(hWnd, NULL, FALSE);

		break;
	
	case IDM_YIELD_TD:
		//if(atm==NULL){ break;}

		length = current->ext - current->filepath - 1;
		_tcsncpy(spath, current->filepath, length);
		_tcscpy(spath + length,_T("_yield.txt"));

		WriteErosionYield(24.0, current->atm, g_frameskip,spath);
		
		ResetWindowText(hWnd);
		InvalidateRect(hWnd, NULL, FALSE);

		break;

//			case IDM_BONDSTATE_TD:
//				//if(atm==NULL){ break;}
//
//				length = current->ext - current->filepath - 1;
//				_tcsncpy(spath, current->filepath, length);
//				_tcscpy(spath + length,_T("_coord2.txt"));
//
//				WriteCoordinateC2(current->atm, g_frameskip, spath);
//
//				ResetWindowText(hWnd);				
//				InvalidateRect(hWnd, NULL, FALSE);
//
//				break;
	
	case IDM_HCRATIO_TD:
		//if(atm==NULL){ break;}

		length = current->ext - current->filepath - 1;
		_tcsncpy(spath, current->filepath, length);
		_tcscpy(spath + length,_T("_hc.txt"));

		WriteHCRatio(current->atm, g_frameskip, spath);
		
		
		ResetWindowText(hWnd);
		InvalidateRect(hWnd, NULL, FALSE);

		break;

	case IDM_MOLECULE_TD:
		//if(atm==NULL){ break;}

		length = current->ext - current->filepath - 1;
		_tcsncpy(spath, current->filepath, length);
		_tcscpy(spath + length,_T("_mol.txt"));

		WriteClassifiedMolecule2(current->atm, g_frameskip, spath);
		
		
		ResetWindowText(hWnd);
		InvalidateRect(hWnd, NULL, FALSE);

		break;

	
	case IDM_RETENTION_TD:
		//if(atm==NULL){ break;}

		length = current->ext - current->filepath - 1;
		_tcsncpy(spath, current->filepath, length);
		_tcscpy(spath + length,_T("_ret.txt"));

		WriteRetention(current->atm, g_frameskip, spath, 3.35);
		
		
		ResetWindowText(hWnd);
		InvalidateRect(hWnd, NULL, FALSE);

		break;

	case IDM_DEPOSITION_TD:
		//if(atm==NULL){ break;}
		
		length = current->ext - current->filepath - 1;
		_tcsncpy(spath, current->filepath, length);
		_tcscpy(spath + length,_T("_depo.txt"));

		WriteDeposition(current->atm, g_frameskip, spath);
		
		
		ResetWindowText(hWnd);
		InvalidateRect(hWnd, NULL, FALSE);
		break;

	//{h
	case IDM_BONDSURVIVE_TD:
		//if(atm==NULL){ break;}

		if(g_movie){
			printf("Prease stop movie.\n");
			break;
		}

		length = current->ext - current->filepath - 1;
		_tcsncpy(spath, current->filepath, length);
		_tcscpy(spath + length,_T("_bondlist000000.txt"));

		WriteBondListBase(current->atm, g_frameskip, spath);
		
		
		ResetWindowText(hWnd);
		InvalidateRect(hWnd, NULL, FALSE);
		break;
	
//֘A===========================
				
//FrameSkip̐ݒ
	case IDM_FRAMESKIP_OFF:
		g_frameskip = 1;
		RecheckMenuFrameSkip(GetMenu(hWnd), wmId);
		break;

	case IDM_FRAMESKIP_2:
		g_frameskip = 2;
		RecheckMenuFrameSkip(GetMenu(hWnd), wmId);
		break;

	case IDM_FRAMESKIP_10:
		g_frameskip = 10;
		RecheckMenuFrameSkip(GetMenu(hWnd), wmId);
		break;

	case IDM_FRAMESKIP_20:
		g_frameskip = 20;
		RecheckMenuFrameSkip(GetMenu(hWnd), wmId);
		break;
		
	case IDM_FRAMESKIP_100:
		g_frameskip = 100;
		RecheckMenuFrameSkip(GetMenu(hWnd), wmId);
		break;
		
	case IDM_FRAMESKIP_1000:
		g_frameskip = 1000;
		RecheckMenuFrameSkip(GetMenu(hWnd), wmId);
		break;
	
	case IDM_MOVIEMODE_SIMPLE:
		g_movie_mode= 0;
		RecheckMenuMovieMode(GetMenu(hWnd), wmId);
		EnableMovieCheckPoint(hWnd, 0);
		break;
	case IDM_MOVIEMODE_CHKPOINT:
		g_movie_mode= 1;
		RecheckMenuMovieMode(GetMenu(hWnd), wmId);
		EnableMovieCheckPoint(hWnd, 1);
		break;

	case IDM_CHKPOINT_INSERT:
		//if(g_checkpoint){
			if(g_files.current){
				g_camera->InsertCheckPoint(g_timeframe, 0);
			}
		//}

		break;
	case IDM_CHKPOINT_SAVE:
		//if(g_checkpoint){
		
		length = current->ext - current->filepath - 1;
		_tcsncpy(spath, current->filepath, length);
		_tcscpy(spath + length,_T(".chp"));

		g_camera->SaveCheckPoint(spath);
		
		break;

	case IDM_CHKPOINT_LOAD:
		length = current->ext - current->filepath - 1;
		_tcsncpy(spath, current->filepath, length);
		_tcscpy(spath + length,_T(".chp"));
		g_camera->LoadCheckPoint(spath);
		break;

	case IDM_CHKPOINT_PLAYALL:
		//if(g_checkpoint){
			//g_checkpoint->Rewind();
			g_timeframe = 0;
			g_camera->RewindCheckPoint();
			
			g_movie = 2; //1: once movie
			g_timerID = SetTimer( hWnd, 1, g_iFPS, NULL);
		//}
		break;
	case IDM_CHKPOINT_PLAYWITHBMP:
		//if(g_checkpoint){
			//g_checkpoint->Rewind();
			g_timeframe = 0;
			g_camera->RewindCheckPoint();
			OutputSequentialBMP(hWnd);
			ResetWindowText(hWnd);
			InvalidateRect(hWnd, NULL, FALSE);
			
			//g_movie = 2; //1: once movie
			//AutoBMP = 1;
			//g_timerID = SetTimer( hWnd, 1, g_iFPS, NULL);

		//}

		break;
		
	case IDM_CHKPOINT_PLAYWITHSTEREOBMP:
			g_timeframe = 0;
			g_camera->RewindCheckPoint();
								
			OutputSequentialStereoBMP(hWnd);
			
			ResetWindowText(hWnd);
			InvalidateRect(hWnd, NULL, FALSE);
		
		break;
		
	case IDM_CHKPOINT_PLAYBEFORE:
		break;
	case IDM_CHKPOINT_PLAYAFTER:

		break;

//XibvVbgo.==========================
	//bmpo
	case IDM_SNAPSHOT_BMP:
		if(g_files.first){
						
			length = current->ext - current->filepath - 1;
			_tcsncpy(spath, current->filepath, length);
			_stprintf(spath + length,_T("%d.bmp"), g_timeframe);
			
			if(g_gpu_DX11 == 0){
				HDC hDC = GetDC(hWnd);
				HGLRC hRC = GetSharedRC(hWnd);
				wglMakeCurrent(hDC,hRC);
				OutputBMfromGLMag(&g_files, spath, 1);
					//AI_getBMfromGL(spath, GL_FRONT);
				wglMakeCurrent(NULL, NULL);
				ReleaseDC(hWnd, hDC);
			}
		}
		break;
		
	//[WTCYbmpo
	case IDM_SNAPSHOT_LARGE_BMP:
		if(g_files.first){

			const int mag = 2;
		
			length = current->ext - current->filepath - 1;
			_tcsncpy(spath, current->filepath, length);
			_stprintf(spath + length,_T("_x%d_%d.bmp"), mag, g_timeframe);
			
			if(g_gpu_DX11 == 0){
				HDC hDC = GetDC(hWnd);
				HGLRC hRC = GetSharedRC(hWnd);
				wglMakeCurrent(hDC,hRC);
				OutputBMfromGLMag(&g_files, spath, mag);
					//AI_getBMfromGLMag(dat, current->atomRenderer, spath, 10);
				wglMakeCurrent(NULL, NULL);
				ReleaseDC(hWnd, hDC);
			}
		}
		break;
		//̎@\
	case IDM_STEREO_BMP:

		if(g_files.first){
			OutputStereoBMP(hWnd);					
		}
		break;
	//epso
	case IDM_SNAPSHOT_EPS:
		if(g_files.first){
			if(current->type == FILETYPE_ATOM){ 
			
				dat = current->atm->GetDataPointer();
			
				length = current->ext - current->filepath - 1;
				_tcsncpy(spath, current->filepath, length);
				_stprintf(spath + length,_T(".eps"), g_timeframe);
			
				
				HDC hDC = GetDC(hWnd);
				HGLRC hRC = GetSharedRC(hWnd);
				wglMakeCurrent(hDC,hRC);
				FILE* fp = OpenAtomEPS(spath, g_client_w,g_client_h);
				DrawAtomEPS(fp, dat, g_client_w,g_client_h);
				CloseAtomEPS(fp);					

				wglMakeCurrent(NULL, NULL);
				ReleaseDC(hWnd, hDC);
			}
		}
		break;
	//md3`ŏo//
	case IDM_SNAPSHOT_MD3:
		if(g_files.first){
			if(current->type == FILETYPE_ATOM){ 
		
			
				dat = current->atm->GetDataPointer();
				
				length = current->ext - current->filepath - 1;
				_tcsncpy(spath, current->filepath, length);
				_stprintf(spath + length,_T("%d.md3"), g_timeframe);
			
				char* mbfpath = MbsDup(spath);
				MD3_Writer* md3 = new MD3_Writer;
				int ierr = md3->Open(mbfpath);

				md3->Write_f(dat->pcnt, dat->knd, (float*)dat->r, NULL, (float*)&(dat->boxaxis),NULL);
				md3->Close();
				delete md3;
			}

		}
		break;

//ݒ֌W.
	//setting.ini[U[̃GfB^ŊJ.
	case IDM_OPEN_SETTING:
		{
			//ݒt@C̃tpX̎擾.
			TCHAR filepath[MAX_PATH];
			int length = GetModuleFileName(NULL, filepath, MAX_PATH);
			if(length > 0){
				TCHAR* p = _tcsrchr(filepath, _T('\\'));
				if( p ) {
					_tcscpy(p + 1, _T("setting.ini"));
					ShellExecute(NULL, _T("open"), filepath, NULL, NULL, SW_SHOWNORMAL);
				}
			}
		}
		break;
	//setting.ini̍ēǂݍ
	case IDM_RELOAD_SETTING:
		LoadSettingFile(_T("setting.ini"));

		break;
//	default:
//	   return DefWindowProc( hWnd, message, wParam, lParam );
	}


	return 0;
}



void RecheckMenuFrameSkip(HMENU hmenu, int wmId){
	
	const int IDcount = 6;
	const UINT IDs[] = {IDM_FRAMESKIP_OFF, IDM_FRAMESKIP_2, IDM_FRAMESKIP_10, IDM_FRAMESKIP_20, IDM_FRAMESKIP_100, IDM_FRAMESKIP_1000};

	MENUITEMINFO menuInfo;
	ZeroMemory(&menuInfo, sizeof(MENUITEMINFO));
	menuInfo.cbSize = sizeof(MENUITEMINFO);
	menuInfo.fMask = MIIM_STATE;
					

	for(int i = 0; i < IDcount; i++){
		if (IDs[i] == wmId){
			menuInfo.fState = MFS_CHECKED;
		}else{
			menuInfo.fState = MFS_UNCHECKED;
		}
		SetMenuItemInfo(hmenu , IDs[i], FALSE , &menuInfo);
	}

	/*
	MENUITEMINFO menuInfo;
	ZeroMemory(&menuInfo, sizeof(MENUITEMINFO));
	menuInfo.cbSize = sizeof(MENUITEMINFO);
	menuInfo.fMask = MIIM_STATE;
					
	menuInfo.fState = MFS_UNCHECKED;
	SetMenuItemInfo(hmenu , IDM_FRAMESKIP_OFF , FALSE , &menuInfo);
	SetMenuItemInfo(hmenu , IDM_FRAMESKIP_2 , FALSE , &menuInfo);
	SetMenuItemInfo(hmenu , IDM_FRAMESKIP_10 , FALSE , &menuInfo);
	SetMenuItemInfo(hmenu , IDM_FRAMESKIP_20 , FALSE , &menuInfo);
	SetMenuItemInfo(hmenu , IDM_FRAMESKIP_100 , FALSE , &menuInfo);
	SetMenuItemInfo(hmenu , IDM_FRAMESKIP_1000 , FALSE , &menuInfo);

	menuInfo.fState = MFS_CHECKED;
	SetMenuItemInfo(hmenu , wmId , FALSE , &menuInfo);
	*/
}

void RecheckMenuMovieMode(HMENU hmenu, int wmId){
		
	const int IDcount = 2;
	const UINT IDs[] = {IDM_MOVIEMODE_SIMPLE, IDM_MOVIEMODE_CHKPOINT};

	MENUITEMINFO menuInfo;
	ZeroMemory(&menuInfo, sizeof(MENUITEMINFO));
	menuInfo.cbSize = sizeof(MENUITEMINFO);
	menuInfo.fMask = MIIM_STATE;
					

	for(int i = 0; i < IDcount; i++){
		if (IDs[i] == wmId){
			menuInfo.fState = MFS_CHECKED;
		}else{
			menuInfo.fState = MFS_UNCHECKED;
		}
		SetMenuItemInfo(hmenu , IDs[i], FALSE , &menuInfo);
	}

	
}


void EnableMovieCheckPoint(HWND hWnd, int flag){
	//Movie Check Point@\On/Offɍ킹Ďg郁j[ݒ.
	//flag1ȂENABLE, 0 ȂDISABLEɂ.

	
	const int IDcount = 3;
	const UINT IDs[] = {IDM_CHKPOINT_INSERT, IDM_CHKPOINT_SAVE, IDM_CHKPOINT_LOAD};

	HMENU hmenu = GetMenu(hWnd);

	UINT uEnable;
	if (flag == 0){
		uEnable = MF_DISABLED;	// | MF_GRAYED
	}else{
		uEnable = MF_ENABLED;
	}

	
	for(int i = 0; i < IDcount; i++){
		EnableMenuItem(hmenu, IDs[i], uEnable);
	}
	DrawMenuBar(hWnd);

	return;


}


void RecheckMenuShapeAtom(HMENU hmenu){
	
	const int IDcount = 4;
	const UINT IDs[] = {IDM_SHAPE_ATOM_NONE, IDM_SHAPE_SPHERE, IDM_SHAPE_POINT, IDM_SHAPE_SPHERE_LARGE};

	MENUITEMINFO menuInfo;
	ZeroMemory(&menuInfo, sizeof(MENUITEMINFO));
	menuInfo.cbSize = sizeof(MENUITEMINFO);
	menuInfo.fMask = MIIM_STATE;
					

	for(int i = 0; i < IDcount; i++){
		if (i == g_visual_atom){
			menuInfo.fState = MFS_CHECKED;
		}else{
			menuInfo.fState = MFS_UNCHECKED;
		}
		SetMenuItemInfo(hmenu , IDs[i], FALSE , &menuInfo);
	}

	
}


void RecheckMenuShapeBond(HMENU hmenu){
	
	const int IDcount = 3;
	const UINT IDs[] = {IDM_SHAPE_BOND_NONE, IDM_SHAPE_PIPE, IDM_SHAPE_ENERGYJ};

	MENUITEMINFO menuInfo;
	ZeroMemory(&menuInfo, sizeof(MENUITEMINFO));
	menuInfo.cbSize = sizeof(MENUITEMINFO);
	menuInfo.fMask = MIIM_STATE;
					
	for(int i = 0; i < IDcount; i++){
		if (i == g_visual_bond){
			menuInfo.fState = MFS_CHECKED;
		}else{
			menuInfo.fState = MFS_UNCHECKED;
		}
		SetMenuItemInfo(hmenu , IDs[i], FALSE , &menuInfo);
	}
}

void RecheckMenuAtomColor(HMENU hmenu){
	
	const int IDcount = 2;
	const UINT IDs[] = {IDM_COLOR_ATOMIC, IDM_COLOR_BONDNUM};

	MENUITEMINFO menuInfo;
	ZeroMemory(&menuInfo, sizeof(MENUITEMINFO));
	menuInfo.cbSize = sizeof(MENUITEMINFO);
	menuInfo.fMask = MIIM_STATE;
				
	for(int i = 0; i < IDcount; i++){
		if (i == g_visual_atomcolor){
			menuInfo.fState = MFS_CHECKED;
		}else{
			menuInfo.fState = MFS_UNCHECKED;
		}
		SetMenuItemInfo(hmenu , IDs[i], FALSE , &menuInfo);
	}
}


void RecheckMenuProjection(HMENU hmenu, int index){
	
	const int IDcount = 2;
	const UINT IDs[] = {IDM_PROJECTION_PERSE, IDM_PROJECTION_ORTHO};

	MENUITEMINFO menuInfo;
	ZeroMemory(&menuInfo, sizeof(MENUITEMINFO));
	menuInfo.cbSize = sizeof(MENUITEMINFO);
	menuInfo.fMask = MIIM_STATE;
				
	for(int i = 0; i < IDcount; i++){
		if (i == index){
			menuInfo.fState = MFS_CHECKED;
		}else{
			menuInfo.fState = MFS_UNCHECKED;
		}
		SetMenuItemInfo(hmenu , IDs[i], FALSE , &menuInfo);
	}

}

void RecheckMenuBGColor(HMENU hmenu, int wmId){
	
	MENUITEMINFO menuInfo;
	ZeroMemory(&menuInfo, sizeof(MENUITEMINFO));
	menuInfo.cbSize = sizeof(MENUITEMINFO);
	menuInfo.fMask = MIIM_STATE;
					
	menuInfo.fState = MFS_UNCHECKED;
	SetMenuItemInfo(hmenu , IDM_BGCOLOR_BLACK, FALSE , &menuInfo);
	SetMenuItemInfo(hmenu , IDM_BGCOLOR_WHITE, FALSE , &menuInfo);
		
	menuInfo.fState = MFS_CHECKED;
	SetMenuItemInfo(hmenu , wmId , FALSE , &menuInfo);
}

void RecheckMenuBoxFrame(HMENU hmenu, int index){
	
	const int IDcount = 2;
	const UINT IDs[] = {IDM_BOXFRAME_OFF, IDM_BOXFRAME_ON};

	MENUITEMINFO menuInfo;
	ZeroMemory(&menuInfo, sizeof(MENUITEMINFO));
	menuInfo.cbSize = sizeof(MENUITEMINFO);
	menuInfo.fMask = MIIM_STATE;
				
	for(int i = 0; i < IDcount; i++){
		if (i == index){
			menuInfo.fState = MFS_CHECKED;
		}else{
			menuInfo.fState = MFS_UNCHECKED;
		}
		SetMenuItemInfo(hmenu , IDs[i], FALSE , &menuInfo);
	}

}


// o[W{bNXpbZ[W nh
LRESULT CALLBACK About( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam )
{
	switch( message )
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if( LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL ) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}


void ResetCurrentFileMenu(HWND hWnd, FileList* current){
	//Jgt@Cɍ킹Ďg郁j[ݒ.
	
	if( current){

		switch(current->type){
		case FILETYPE_ATOM:		//qq̎
			EnableMenuItem(GetMenu(hWnd), 0, MF_BYPOSITION | MF_ENABLED);
			EnableMenuItem(GetMenu(hWnd), 1, MF_BYPOSITION | MF_ENABLED);
			EnableMenuItem(GetMenu(hWnd), 2, MF_BYPOSITION | MF_ENABLED);
			EnableMenuItem(GetMenu(hWnd), 3, MF_BYPOSITION | MF_DISABLED | MF_GRAYED);
			EnableMenuItem(GetMenu(hWnd), 4, MF_BYPOSITION | MF_DISABLED | MF_GRAYED);
			EnableMenuItem(GetMenu(hWnd), 5, MF_BYPOSITION | MF_ENABLED);
			EnableMenuItem(GetMenu(hWnd), 6, MF_BYPOSITION | MF_ENABLED);
			
			RecheckMenuShapeAtom(GetMenu(hWnd));
			RecheckMenuShapeBond(GetMenu(hWnd));
			RecheckMenuAtomColor(GetMenu(hWnd));
			DrawMenuBar(hWnd);
			return;
		case FILETYPE_TRAJ:		//qq̎
			EnableMenuItem(GetMenu(hWnd), 0, MF_BYPOSITION | MF_ENABLED);
			EnableMenuItem(GetMenu(hWnd), 1, MF_BYPOSITION | MF_ENABLED);
			EnableMenuItem(GetMenu(hWnd), 2, MF_BYPOSITION | MF_DISABLED | MF_GRAYED);
			EnableMenuItem(GetMenu(hWnd), 3, MF_BYPOSITION | MF_ENABLED);
			EnableMenuItem(GetMenu(hWnd), 4, MF_BYPOSITION | MF_DISABLED | MF_GRAYED);
			EnableMenuItem(GetMenu(hWnd), 5, MF_BYPOSITION | MF_ENABLED);
			EnableMenuItem(GetMenu(hWnd), 6, MF_BYPOSITION | MF_ENABLED);
			DrawMenuBar(hWnd);
			return;
		case FILETYPE_FIELD:		//qq̎
			EnableMenuItem(GetMenu(hWnd), 0, MF_BYPOSITION | MF_ENABLED);
			EnableMenuItem(GetMenu(hWnd), 1, MF_BYPOSITION | MF_ENABLED);
			EnableMenuItem(GetMenu(hWnd), 2, MF_BYPOSITION | MF_DISABLED | MF_GRAYED);
			EnableMenuItem(GetMenu(hWnd), 3, MF_BYPOSITION | MF_DISABLED | MF_GRAYED);
			EnableMenuItem(GetMenu(hWnd), 4, MF_BYPOSITION | MF_ENABLED);
			EnableMenuItem(GetMenu(hWnd), 5, MF_BYPOSITION | MF_ENABLED);
			EnableMenuItem(GetMenu(hWnd), 6, MF_BYPOSITION | MF_ENABLED);
			DrawMenuBar(hWnd);
			return;
		case FILETYPE_LMC:		//qq̎
			EnableMenuItem(GetMenu(hWnd), 0, MF_BYPOSITION | MF_ENABLED);
			EnableMenuItem(GetMenu(hWnd), 1, MF_BYPOSITION | MF_ENABLED);
			EnableMenuItem(GetMenu(hWnd), 2, MF_BYPOSITION | MF_DISABLED | MF_GRAYED);
			EnableMenuItem(GetMenu(hWnd), 3, MF_BYPOSITION | MF_DISABLED | MF_GRAYED);
			EnableMenuItem(GetMenu(hWnd), 4, MF_BYPOSITION | MF_DISABLED | MF_GRAYED);
			EnableMenuItem(GetMenu(hWnd), 5, MF_BYPOSITION | MF_ENABLED);
			EnableMenuItem(GetMenu(hWnd), 6, MF_BYPOSITION | MF_ENABLED);
			
			RecheckMenuShapeAtom(GetMenu(hWnd));
			RecheckMenuShapeBond(GetMenu(hWnd));
			RecheckMenuAtomColor(GetMenu(hWnd));
			DrawMenuBar(hWnd);
			return;
		}
	}

	//t@CJĂȂƂAΉtH[}bg̎.
	
	EnableMenuItem(GetMenu(hWnd), 2, MF_BYPOSITION | MF_DISABLED | MF_GRAYED);
	EnableMenuItem(GetMenu(hWnd), 3, MF_BYPOSITION | MF_DISABLED | MF_GRAYED);
	EnableMenuItem(GetMenu(hWnd), 4, MF_BYPOSITION | MF_DISABLED | MF_GRAYED);
	EnableMenuItem(GetMenu(hWnd), 5, MF_BYPOSITION | MF_DISABLED | MF_GRAYED);
	EnableMenuItem(GetMenu(hWnd), 6, MF_BYPOSITION | MF_DISABLED | MF_GRAYED);
	DrawMenuBar(hWnd);

	return;


}


void OutputSequentialStereoBMP(HWND hWnd){

	
	int res = 0;
	while(res==0){
		//1t[i߂
		OutputStereoBMP(hWnd);
		Sleep(0);
		
		res = PlayMovie();
	}
}

		
void OutputStereoBMP(HWND hWnd){
	
	TCHAR spath[MAX_PATH];
	
	HDC hDC = GetDC(hWnd);
	HGLRC hRC = GetSharedRC(hWnd);
	wglMakeCurrent(hDC,hRC);

	//Eڗp摜
	FileList* current = g_files.current;
	
	int length = current->ext - current->filepath - 1;
	_tcsncpy(spath, current->filepath, length);
	_stprintf(spath + length,_T("%d_right.bmp"), outNum);
	//outNum++;
	printf("%s\n",spath);

	g_camera->PushState();
	g_camera->SetStereoMode(2.0);
	double radius = g_camera->GetForcusDistance();
	double delta_aglxy = g_stereo_eyelength / radius;
	g_camera->RotatePosOnUpAxis(delta_aglxy);

	OutputBMfromGLMag(&g_files, spath, 1);

	//ڗp摜
	_stprintf(spath + length,_T("%d_left.bmp"), outNum);
	outNum++;
	printf("%s\n",spath);

	g_camera->RotatePosOnUpAxis(-2.0*delta_aglxy);
	
//				cam_info.focus_y -= width2 * cos(cam_info.aglxy);
//				cam_info.focus_x += width2 * sin(cam_info.aglxy);

	OutputBMfromGLMag(&g_files, spath, 1);

	//g_camera->RotatePosOnUpAxis(delta_aglxy);
	g_camera->PullState();

}

void OutputSequentialBMP(HWND hWnd){

	TCHAR spath[MAX_PATH];

	FileList* current = g_files.current;
	int length = current->ext - current->filepath - 1;
	_tcsncpy(spath, current->filepath, length);

	HDC hDC = GetDC(hWnd);
	HGLRC hRC = GetSharedRC(hWnd);
	wglMakeCurrent(hDC,hRC);
		
	int res = 0;
	while(res==0){

		//t@C//
		_stprintf(spath + length,_T("%d.bmp"), outNum);
		outNum++;

		//摜
		OutputBMfromGLMag(&g_files, spath, 1);

		Sleep(0);
		//1t[i߂
		res = PlayMovie();
	}

	wglMakeCurrent(NULL, NULL);
	ReleaseDC(hWnd, hDC);



}

